from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, Boolean

Mcxload_V0_1_0 = CommandToolBuilder(tool="mcxload", base_command=["mcxload"], inputs=[ToolInput(tag="in_abc", input_type=File(optional=True), prefix="-abc", doc=InputDocumentation(doc="input file in abc format")), ToolInput(tag="in_input_file_in__format", input_type=Int(optional=True), prefix="-123", doc=InputDocumentation(doc="input file in 123 format")), ToolInput(tag="in_etc", input_type=File(optional=True), prefix="-etc", doc=InputDocumentation(doc="input file in etc format")), ToolInput(tag="in_etc_a_i", input_type=File(optional=True), prefix="-etc-ai", doc=InputDocumentation(doc="input file in etc format, auto-increment columns")), ToolInput(tag="in_s_if", input_type=File(optional=True), prefix="-sif", doc=InputDocumentation(doc="input file in sif format")), ToolInput(tag="in_input_file_numerical", input_type=Int(optional=True), prefix="-235", doc=InputDocumentation(doc="input file in numerical etc format")), ToolInput(tag="in_two_three_five_a_i", input_type=Int(optional=True), prefix="-235-ai", doc=InputDocumentation(doc="input file in numerical etc format, auto-increment columns")), ToolInput(tag="in_packed", input_type=File(optional=True), prefix="-packed", doc=InputDocumentation(doc="input file in packed format")), ToolInput(tag="in_pack_cnum", input_type=Int(optional=True), prefix="-pack-cnum", doc=InputDocumentation(doc="Number of columns")), ToolInput(tag="in_pack_rnum", input_type=Int(optional=True), prefix="-pack-rnum", doc=InputDocumentation(doc="Number of rows")), ToolInput(tag="in_stream_mirror", input_type=Boolean(optional=True), prefix="--stream-mirror", doc=InputDocumentation(doc="add y -> x when x -> y")), ToolInput(tag="in_stream_split", input_type=Boolean(optional=True), prefix="--stream-split", doc=InputDocumentation(doc="assume two independent domains (e.g. bipartite graph)")), ToolInput(tag="in_output_matrix_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="output matrix to file <fname>")), ToolInput(tag="in_strict_tab", input_type=File(optional=True), prefix="-strict-tab", doc=InputDocumentation(doc="use dom tab in file <fname>, die on miss")), ToolInput(tag="in_restrict_tab", input_type=File(optional=True), prefix="-restrict-tab", doc=InputDocumentation(doc="use dom tab in file <fname>, ignore miss")), ToolInput(tag="in_extend_tab", input_type=File(optional=True), prefix="-extend-tab", doc=InputDocumentation(doc="use dom tab in file <fname>, extend if necessary")), ToolInput(tag="in_write_tab", input_type=File(optional=True), prefix="-write-tab", doc=InputDocumentation(doc="output domain tab to file <fname>")), ToolInput(tag="in_one_two_three_max", input_type=Int(optional=True), prefix="-123-max", doc=InputDocumentation(doc="set column and row ranges with -123 option")), ToolInput(tag="in_strict_tabc", input_type=File(optional=True), prefix="-strict-tabc", doc=InputDocumentation(doc="use col tab in file <fname>, die on miss")), ToolInput(tag="in_restrict_tabc", input_type=File(optional=True), prefix="-restrict-tabc", doc=InputDocumentation(doc="use col tab in file <fname>, ignore miss")), ToolInput(tag="in_extend_tabc", input_type=File(optional=True), prefix="-extend-tabc", doc=InputDocumentation(doc="use col tab in file <fname>, extend if necessary")), ToolInput(tag="in_write_tabc", input_type=File(optional=True), prefix="-write-tabc", doc=InputDocumentation(doc="output column tab to file <fname>")), ToolInput(tag="in_one_two_three_max_c", input_type=Int(optional=True), prefix="-123-maxc", doc=InputDocumentation(doc="set column range with -123 option")), ToolInput(tag="in_strict_tab_r", input_type=File(optional=True), prefix="-strict-tabr", doc=InputDocumentation(doc="use row tab in file <fname>, die on miss")), ToolInput(tag="in_restrict_tab_r", input_type=File(optional=True), prefix="-restrict-tabr", doc=InputDocumentation(doc="use row tab in file <fname>, ignore miss")), ToolInput(tag="in_extend_tab_r", input_type=File(optional=True), prefix="-extend-tabr", doc=InputDocumentation(doc="use row tab in file <fname>, extend if necessary")), ToolInput(tag="in_write_tab_r", input_type=File(optional=True), prefix="-write-tabr", doc=InputDocumentation(doc="output row tab to file <fname>")), ToolInput(tag="in_one_two_three_max_r", input_type=Int(optional=True), prefix="-123-maxr", doc=InputDocumentation(doc="set row range with -123 option")), ToolInput(tag="in_re", input_type=Int(optional=True), prefix="-re", doc=InputDocumentation(doc="deduplicate repeated entries")), ToolInput(tag="in_stream_tf", input_type=Boolean(optional=True), prefix="-stream-tf", doc=InputDocumentation(doc="<func(arg)[, func(arg)]*> apply unary transformations to stream values")), ToolInput(tag="in_tf", input_type=Boolean(optional=True), prefix="-tf", doc=InputDocumentation(doc="<func(arg)[, func(arg)]*>        apply unary transformations to matrix")), ToolInput(tag="in_stream_log", input_type=Boolean(optional=True), prefix="--stream-log", doc=InputDocumentation(doc="take log of stream value")), ToolInput(tag="in_stream_neg_log", input_type=Boolean(optional=True), prefix="--stream-neg-log", doc=InputDocumentation(doc="take negative log of stream value")), ToolInput(tag="in_stream_neg_log_one_zero", input_type=Boolean(optional=True), prefix="--stream-neg-log10", doc=InputDocumentation(doc="take negative log-10 of stream value")), ToolInput(tag="in_expect_values", input_type=Boolean(optional=True), prefix="--expect-values", doc=InputDocumentation(doc="accept extended SIF or ETC format (label:weight fields)")), ToolInput(tag="in_ri", input_type=Int(optional=True), prefix="-ri", doc=InputDocumentation(doc="combine input matrix with its transpose")), ToolInput(tag="in_transpose", input_type=Boolean(optional=True), prefix="--transpose", doc=InputDocumentation(doc="transpose result")), ToolInput(tag="in_write_binary", input_type=Boolean(optional=True), prefix="--write-binary", doc=InputDocumentation(doc="output matrix in binary format")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="debug")), ToolInput(tag="in_help", input_type=Boolean(optional=True), prefix="--help", doc=InputDocumentation(doc="print this help"))], outputs=[ToolOutput(tag="out_output_matrix_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_matrix_file", type_hint=File()), doc=OutputDocumentation(doc="output matrix to file <fname>")), ToolOutput(tag="out_write_tab", output_type=File(optional=True), selector=InputSelector(input_to_select="in_write_tab", type_hint=File()), doc=OutputDocumentation(doc="output domain tab to file <fname>")), ToolOutput(tag="out_write_tabc", output_type=File(optional=True), selector=InputSelector(input_to_select="in_write_tabc", type_hint=File()), doc=OutputDocumentation(doc="output column tab to file <fname>")), ToolOutput(tag="out_write_tab_r", output_type=File(optional=True), selector=InputSelector(input_to_select="in_write_tab_r", type_hint=File()), doc=OutputDocumentation(doc="output row tab to file <fname>"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Mcxload_V0_1_0().translate("wdl", allow_empty_container=True)

